# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section   free
%define base_name poi
%define namedversion 3.8
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           apache-%{base_name}
Version:        3.8
Release:        2%{?dist}
Epoch:          0
Summary:        Java API To Access Microsoft Format Files

Group:          Development/Libraries/Java
License:        Apache Software License
URL:            http://poi.apache.org/
Source0:        apache-poi-3.8.tgz
# svn export http://svn.apache.org/repos/asf/poi/tags/REL_3_8_FINAL/ apache-poi-3.8
# tar czf apache-poi-3.8.tgz apache-poi-3.8/
Source1:        http://mirrors.ibiblio.org/pub/mirrors/maven2/org/apache/poi/poi/3.8/poi-3.8.pom
Source3:        http://mirrors.ibiblio.org/pub/mirrors/maven2/org/apache/poi/poi-scratchpad/3.8/poi-scratchpad-3.8.pom
Source4:        http://mirrors.ibiblio.org/pub/mirrors/maven2/org/apache/poi/poi-examples/3.8/poi-examples-3.8.pom
Source5:        http://mirrors.ibiblio.org/pub/mirrors/maven2/org/apache/poi/poi-ooxml-schemas/3.8/poi-ooxml-schemas-3.8.pom
Source6:        http://mirrors.ibiblio.org/pub/mirrors/maven2/org/apache/poi/poi-ooxml/3.8/poi-ooxml-3.8.pom
Source7:        http://mirrors.ibiblio.org/pub/mirrors/maven2/org/apache/poi/poi-excelant/3.8/poi-excelant-3.8.pom

Source8:        OfficeOpenXML-XMLSchema.zip
# extract it from http://www.ecma-international.org/publications/files/ECMA-ST/Office%20Open%20XML%201st%20edition%20Part%204%20(PDF).zip
Source9:        http://www.eu.apache.org/dist/poi/release/src/poi-src-3.8-20120326.tar.gz

Patch0:         apache-poi-build.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} )
BuildArch:      noarch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  ant-junit
BuildRequires:  junit >= 0:3.8.1
BuildRequires:  ant-trax
BuildRequires:  apache-commons-codec
BuildRequires:  apache-commons-logging >= 0:1.1
BuildRequires:  dom4j >= 0:1.6.1
BuildRequires:  geronimo-stax-1.0-api
BuildRequires:  log4j >= 0:1.2.13
BuildRequires:  xmlbeans
Requires:  apache-commons-codec
Requires:  apache-commons-logging >= 0:1.1
Requires:  dom4j >= 0:1.6.1
Requires:  stax_1_0_api
Requires:  log4j >= 0:1.2.13
Requires:  xmlbeans

%description
The Apache POI Project's mission is to create and maintain 
Java APIs for manipulating various file formats based upon 
the Office Open XML standards (OOXML) and Microsoft's OLE 2 
Compound Document format (OLE2). In short, you can read and 
write MS Excel files using Java. In addition, you can read 
and write MS Word and MS PowerPoint files using Java. 
Apache POI is your Java Excel solution (for Excel 97-2008). 
We have a complete API for porting other OOXML and OLE2 
formats and welcome others to participate.

OLE2 files include most Microsoft Office files such as XLS,
DOC, and PPT as well as MFC serialization API based file 
formats. The project provides APIs for the OLE2 Filesystem 
(POIFS) and OLE2 Document Properties (HPSF).

Office OpenXML Format is the new standards based XML file 
format found in Microsoft Office 2007 and 2008. This 
includes XLSX, DOCX and PPTX. The project provides a low 
level API to support the Open Packaging Conventions using 
openxml4j.

For each MS Office application there exists a component 
module that attempts to provide a common high level Java 
api to both OLE2 and OOXML document formats. This is most 
developed for Excel workbooks (SS=HSSF+XSSF). Work is 
progressing for Word documents (HWPF+XWPF) and PowerPoint 
presentations (HSLF+XSLF).

The project has recently added support for Outlook (HSMF). 
Microsoft opened the specifications to this format in 
October 2007. We would welcome contributions.

There are also projects for Visio (HDGF) and Publisher (HPBF).

As a general policy we collaborate as much as possible with 
other projects to provide this functionality. Examples 
include: Cocoon for which there are serializers for HSSF; 
Open Office.org with whom we collaborate in documenting the 
XLS format; and Lucene for which we provide format 
interpretors. When practical, we donate components directly 
to those projects for POI-enabling them. 


%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
%{summary}.

%package        manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description    manual
%{summary}.


%prep
%setup -q 
find . -name "*.jar" -exec mv {} {}.no \;
%patch0 -b .sav0
build-jar-repository -s -p lib \
ant \
commons-codec \
commons-logging \
junit \
log4j 

build-jar-repository -s -p ooxml-lib \
dom4j \
geronimo-stax-1.0-api 

ln -s $(build-classpath geronimo-stax-1.0-api) ooxml-lib/stax-api.jar
ln -s $(build-classpath xmlbeans/xbean) ooxml-lib/xmlbeans.jar

cp %{SOURCE8} ooxml-lib

tar xzf %{SOURCE9}
rm -rf poi-%{version}/docs/apidocs

%build
export LANG=en_US.UTF-8

ant compile-ooxml-xsds
export ANT_OPTS="-Xmx256m -Djava.awt.headless=true -Ddisconnected=true"
ant -Dhalt.on.test.failure=false jar test jar-src javadocs

%install
rm -rf $RPM_BUILD_ROOT

install -dm 755 $RPM_BUILD_ROOT%{_javadir}/%{base_name}
cp -p build/dist/%{base_name}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{base_name}/%{name}-%{version}.jar
cp -p build/dist/%{base_name}-examples-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{base_name}/%{name}-examples-%{version}.jar
cp -p build/dist/%{base_name}-excelant-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{base_name}/%{name}-excelant-%{version}.jar
cp -p build/dist/%{base_name}-ooxml-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{base_name}/%{name}-ooxml-%{version}.jar
cp -p build/dist/%{base_name}-ooxml-schemas-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{base_name}/%{name}-ooxml-schemas-%{version}.jar
cp -p build/dist/%{base_name}-scratchpad-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{base_name}/%{name}-scratchpad-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{base_name} && for jar in %{name}*-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|apache-||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{base_name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{base_name}-%{name}.pom
%add_to_maven_depmap org.apache.poi %{base_name} %{version} JPP/%{base_name} %{name}
#install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{base_name}-%{name}-contrib.pom
#%add_to_maven_depmap org.apache.poi %{base_name}-contrib %{version} JPP/%{base_name} %{name}-contrib
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{base_name}-%{name}-scratchpad.pom
%add_to_maven_depmap org.apache.poi %{base_name}-scratchpad %{version} JPP/%{base_name} %{name}-scratchpad
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{base_name}-%{name}-examples.pom
%add_to_maven_depmap org.apache.poi %{base_name}-examples %{version} JPP/%{base_name} %{name}-examples
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{base_name}-%{name}-ooxml-schemas.pom
%add_to_maven_depmap org.apache.poi %{base_name}-ooxml-schemas %{version} JPP/%{base_name} %{name}-ooxml-schemas
install -m 644 %{SOURCE6} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{base_name}-%{name}-ooxml.pom
%add_to_maven_depmap org.apache.poi %{base_name}-ooxml %{version} JPP/%{base_name} %{name}-ooxml
install -m 644 %{SOURCE7} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{base_name}-%{name}-excelant.pom
%add_to_maven_depmap org.apache.poi %{base_name}-excelant %{version} JPP/%{base_name} %{name}-excelant

#javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/tmp/site/build/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf docs/apidocs

#manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr poi-%{version}/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p legal/LICENSE $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
ln -s %{_javadocdir}/%{name}-%{version} $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/apidocs # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-%{version}/LICENSE
%dir %{_javadir}/%{base_name}
%{_javadir}/%{base_name}/*.jar
%{_mavendepmapfragdir}/*
%{_datadir}/maven2/poms/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%files manual
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Wed Oct 31 2012 Will Tatam <will.tatam@red61.com> 3.8-2
- Auto rebuild for JPackage 6 in centos5 mock

* Sun Aug 19 2012 Ralph Apel <r.apel at r-apel.de> - 0:3.8-1
- 3.8 final

* Sun Feb 12 2012 Ralph Apel <r.apel at r-apel.de> - 0:3.8-0.b5.1
- 3.8

* Sun Feb 12 2012 Ralph Apel <r.apel at r-apel.de> - 0:3.7-1
- 3.7

* Fri Feb 19 2010 Ralph Apel <r.apel at r-apel.de> - 0:3.6-1
- 3.6 with ooxml

* Mon Mar 16 2009 Ralph Apel <r.apel at r-apel.de> - 0:3.2-1.jpp5
- First JPP-5 release

* Mon May 08 2006 Ralph Apel <r.apel at r-apel.de> - 0:2.5.1-2jpp
- First JPP-1.7 release

* Wed Aug 24 2005 Ralph Apel <r.apel at r-apel.de> - 0:2.5.1-1jpp
- Upgrade to 2.5.1
- Extend scratchpad with unreleased hwpf from CVS

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:2.5-4jpp
- Rebuild with ant-1.6.2

* Fri Aug 06 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.5-3jpp
- Void change

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:2.5-2jpp
- Upgrade to Ant 1.6.X

* Thu May 06 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.5-1jpp
- upgrade to 2.5-final

* Fri Feb 27 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0-1jpp
- First JPackage release
